*****************************************************
*                 LINE pour HP28S                   *
*           280,5 octets  cksum # A943h             *
*                                                   *
*    auteur Guy Toublanc           le 26/06/1994    *
*                                                   *
*   syntaxe :                                       *
*      niveau 2 : ( X1 , Y1 ) origine du segment    *
*      niveau 1 : ( X2 , Y2 ) extrmit du segment  *
*                                                   *
*                                                   *
* X1, Y1, X2, Y2 : rels                            *
* Les extrmits P1 et P2 quelconques dans le plan  *
* complexe                                          *
*                                                   *
*  sytme de coordonnes absolues :                 *
*                                                   *
*        0  -------------------------> 136          *
*           |                                       *
*           |                                       *
*           |                                       *
*        31 V                                       *
*                                                   *
*  flag 9 pos : ligne efface                      *
*                                                   *
* fichier source compilable sur PC par RPLCOMP de HP*
*****************************************************

CODE
         gosbvl  =SAVPTR
         c=0     w          * pour initaialiser
         c=c-1   a          * c(a) := FFFFFh
         c=0     b          * c(a) := FFF00h
         d0=c               * @ speed
         dat0=c  xs         * pour speed maxi
         d0=(5)  #c0111     * @ flag 9
         a=dat0  1          * flags 12  9
         clrst              * intilialise st 2 et 3
         ?abit=0 0          * 9 FC?
         goyes   lineon     * oui alors on allumera
         st=1    3          * pour ligne  effacer
lineon
         c=dat1  a          * adresse complexe niv.1
         gosub   pop&conv   * X2 : conversion en hexa
         r4=c               * sauve X2 -> R4
         gosub   popim      * conversion Y2 en hexa
         r0=c               * sauve Y2 -> R0
         d0=d0+  5          * @ 2ime niveau
         c=dat0  a          * adresse 1er complexe
         gosub   pop&conv   * X1 : conversion
         r2=c               * sauve X1 -> R2
         gosub   popim      * conversion Y1 en hexa
         r3=c               * sauve Y1 -> R3
         a=r0               * Y2
         ?a#c    a          * Y2 <> Y1 ?
         goyes   okline
okline   c=r4               * X2
         a=r2               * X1
         goc     line       * si test okline
         ?a#c    a          * X1 <> X2 ?
         goyes   line       * oui ligne traable
         ar3ex
         goto    point      * non alors 1 point

line     p=      4          * pour test des signes
         gosub   XY         * 2|X2-X1| signe -> A(S)
         d=c     w          * sauvegarde pour index
         ar3ex               * sauvegarde 2|X2-X1|
         c=r0               * Y2    a := Y1
         gosub   XY         * 2|Y2-Y1| signe -> A(S)
         ?d<c    a          * delta X < delta Y
         goyes   dx<dy
         cdex    a          * non alors permutation 
         st=1    2          * et repre avec ST 2
         ar3ex              * et change des deltas
dx<dy
         r4=c               * sauve 2DX (ou 2DY)
         r2=a               * sauve X1 (ou Y1)
         cdex    a          * change 2DX<->2DY
         r0=c               * sauve 2DY (ou 2DX)
         dsrb               * |X2-X1| (ou |Y2-Y1|)
         c=c-d   a          * err= 2DY - DX
         b=c     a          * sauve err
         d=d-1   a          * dpart pour compteur

loop     gosub   plot       * trace le point Xi,Yi
         p=      4          * pour test de signes
         ?b#0    p          *  while err >= 0
         goyes   tst        * 
         a=r4               * 2DX
         c=r3               * Xi

loop2    c=c+1   a          * Xi + 1
         ?c=0    s          * X2 >= X1 ?
         goyes   x2>x1      * oui Xi+1 = Xi + 1
         c=c-con a,2        * non : Xi+1 = Xi - 1
x2>x1
         b=b-a   a          * err = err - 2DX
         gonc    loop2
         r3=c               * sauve Xi+1

tst      a=r2               * end while A(A) := Yi
         a=a+1   a          * Yi + 1
         ?a=0    s          * Y2 >= Y1 ?
         goyes   y2>y1      * oui Yi+1 = Yi + 1
         a=a-con a,2        * non : Yi+1 = Yi - 1
y2>y1
         r2=a               * sauve Yi+1
         c=r0               * 2DY
         b=b+c   a          * err = err + 2 DY
         d=d-1   a          * actualise index
         gonc    loop       * point suivant

point    gosub   plot       * dernier point et sortie
         govlng  =GETPTRLOOP

plot     p=      0          * A(A) := Yi (ou Xi)
         c=r3               * Xi (ou Yi)
         ?st=1   2          * DY >= DX ?
         goyes   norm
         acex    a          * non : permutation
norm
         d1=c               * sauve Yi
         lc(5)   136
         ?c<a    a          * Xi > 136 ?
         rtnyes             * oui on fait rien
         lc(2)   67
         ?c>=a   b          * Xi <= 67 ?
         goyes   left       * oui demi cran gauche
         a=a-c   a          * Xi pour 1/2 cr. droit
left
         lchex   ffbf8      * adresse 1/2 cr. droit
         gonc    right      * si Xi > 67 saut cr-dr
         lchex   840        * FF840 pour 1/2 cr-g
right
         a=a+a   a
         a=a+a   a
         a=a+a   a          * colonne pour Xi
         a=a+c   a          * adresse colonne
         ad1ex              * @ colonne  A(A) := Yi
         d0=a               * sauve Yi
         lc(5)   31
         ?c<a    a          * Yi > 31 ?
         rtnyes             * oui on ne fait rien
         asrb
         asrb               * Yi en quartets
         cd1ex              * adresse colonne
         c=c+a   a          * adresse quartet pour Yi
         cd1ex              * @ quartet Yi
         ad0ex              * Yi
         lchex   3
         a=a&c   p          * Yi modulo 4
         csr     a          * rcupre 1 de 1F (31d)
         gonc    decr       * dpart pour position

loop4    c=c+c   p          * position pixel dans nib
decr     a=a-1   p          * compteur
         gonc    loop4

         a=dat1  b          * quartet du pixel en mem
         ?st=0   3          * PIXON ?
         goyes   pixon
         a=-a-1  p          * inversion pour PIXOFF     
pixon
         a=a!c   p          * OR pour PIXON ou PIXOFF
         goc     pixon2     * saut pour PIXON
         a=-a-1  p          * inversion pour PIXOFF
pixon2
         dat1=a  1          * quartet modifi
         rtn

pop&conv cd1ex              * @ prologue
         d0=c               * sauve D1
         d1=d1+  4

popim    d1=d1+  1          * @ exposant
         a=0     a
         a=dat1  x          * exposant
         lchex   500
         ?c>a    x          * exposant positif ?
         goyes   exppos
         b=0     a          * 0,.... arrondi  0
         d1=d1+  15         * pour partie imag.
         gonc    convrtn
exppos
         lchex   003        * si exposant > 3
         ?c>=a   x          * alors exposant = 3
         goyes   exp<4
         a=c     x
exp<4
         d1=d1+  14         * @ digit de poids fort
         ad1ex              * A(A) := D1
         cd1ex              * C(A) := exposant
         p=c     0          * P := exposant
         c=a-c   a          * adresse digit de poids
         d1=c               * faible (mantisse)
         a=0     a
         a=dat1  wp         * mantisse
         b=a     a          * sauvegarde
         d=0     a          * initialisation
         c+p+1              * adresse aprs mantisse
         d1=c               * @ le signe
         p=      0
         c=0     a
         lchex   6          * 3e cste de conversion
         rstk=c             * sauvegarde
         lchex   9c         * 2e cste de conversion
         rstk=c             * sauvegarde
         lchex   c18        * 1e cste de conversion
         p=      3          * compteur pour loop5

loop5    a=b     p          * et pointeur de digits
         gonc    decr3      * dpart conversion

loop3    d=d+c   a
decr3    a=a-1   p
         gonc    loop3

         p=p-1              * position suivante
         ?p=     0          * plus de digits ?
         goyes   cont       * alors sortie de loop5
         c=rstk             * dpile constante suiv.
         gonc    loop5      * tour suivant de boucle

cont     c=d     a
         b=b-c   a          * rsultat en hexa
         a=dat1  1          * signe
         ?a=0    p          * positif ?
         goyes   pos
         b=-b    a          * si non entier sign
pos
convrtn  c=b     a          * nombre converti
         rtn

XY       c=c-a   a          * ici P=4   A(S) := 0
         ?c=0    p          * diffrence positive ?
         goyes   xy2>xy1
         a=a+1   s          * sinon A(S) := 1
         c=-c    a          * et valeur absolue
xy2>xy1
         c=c+c   a          * 2*ABS(diffrence)
         rtn
ENDCODE
