::                   ( dbut structure programme )
 CK1NOLASTWD       ( vrifie si 1 niveau de pile )
CODE
        A=DAT1 A             * adresse de l'objet
        GOSBVL =SAVPTR       * sauve les pointeurs
*                              pour PUSH#ALOOP
        GOVLNG =PUSH#ALOOP   * pousse l'adresse en
*                A(A) sur la pile et retour au RPL 
ENDCODE
 SWAP              ( niveau 2 : adresse objet en )
            (  system binary    niveau 1 : objet )
 OCRC            ( BYTES interne sur un objet -> )
      ( longueur en quartets : 1 SB  et checksum ) 
 DROPOVER       ( drop sur le checksum puis over )
         ( pour dupliquer l'adresse  au niveau 1 )
 #+-1       ( adresse objet + longueur objet - 1 )
                           ( = adresse fin en SB )
 SWAP                     ( niv. 2 : adresse fin )
                      ( niveau 1 : adresse objet )
 #>HXS              ( conversion adresse objet : )
                ( sytem binary -> integer binary )
 ZERO               ( initialisation avec SB 0 : )
         ( compteur de blocs de code  assembleur )
 NULLLAM        ( nom nul pour variable locale : )
                                   ( adresse fin )
 NULLLAM        ( nom nul pour variable locale : )
             ( adresse dbut -> adresse courante )
 NULLLAM        ( nom nul pour variable locale : )
                  ( compteur de blocs assembleur )
 THREE{}N           ( liste avec les 3 noms nuls )
           ( pour cration des variables locales )
 BIND       ( cre l'environnement des variables )
                                       ( locales )
 NULL$            ( initialise la chane listing )
                          ( avec la chane nulle )
 BEGIN   ( commence la boucle DO ... UNTIL.. END )
 2GETLAM              ( 2ime variable locale -> )
                  ( adresse courante sur la pile )
 ROMPTR 4D2 2   ( appelle DCADR de <-RPL->  pour )
            ( dcompilation  l'adresse courante )
 2PUTLAM         ( sauve l'adresse suivante dans )
                      ( la 2ime variable locale )
 DUP               ( duplique la chane courante )
                              ( de dcompilation )
 FIVE                       ( system binary <5h> )
 1_#1-SUB$  ( fait un SUB de 1  4 sur la chane )
                     ( courante de dcompilation ) 
 $ "CODE"              ( gnre la chane "CODE" )
 HXS#HXS         ( compare "CODE" au sub 1  4 : )
      ( si chanes diffrentes renvoie 1 sinon 0 )
 %0=                ( renvoie le boolen TRUE si )
                   ( le rel est nul sinon FALSE ) 
 IT                                    ( IF THEN )
 ::               ( si TRUE excute ce programme )
  ROMPTR 4D2 1   ( appelle ->RPL de <-RPL-> pour )
                              ( compiler le code )
  $ "Code"             ( gnre la chane "Code" )
  1GETLAM               ( 1re variable locale : )
               ( compteur de blocs de code en SB )
  #1+DUP        ( actualise compteur et duplique )
                                  ( cette valeur )
  1PUTLAM       ( sauve le compteur dans la 1re )
                               ( variable locale )
  UNCOERCE    ( conversion sytem binary <-> rel )
  DO>STR        ( conversion rel -> chane pour )
                        ( indice de bloc de code )
  SWAPOVER  ( niv. 3 : indice    niv. 2 : "Code" )
                               ( niv. 1 : indice )
  &$      ( concatne "Code" et la chane indice )
  $>ID                ( conversion chane -> nom )
  4ROLL           ( niveau 1 : la chane listing )
  $ "CODE_"            ( gnre la chane "CODE" )
  &$    ( concatne la chane listing et "CODE_" )
  ROT        ( niv. 2 : chane listing + "CODE_" )
                               ( niv. 1 : indice )
 ;                         ( fin de ce programme )
  NEWLINE$&$        ( ajoute newline  la chane )
               ( courante ou  la chane indice  )
  &$               ( concatne la chane listing )
                               ( et cette chane )
 2GETLAM               ( 2ime variable locale : )
           ( adresse courante en entier binaire  )
 HXS>#               ( conversion binary integer )
                              ( -> system binary )
 3GETLAM               ( 3ime variable locale : )
                ( adresse de fin en sytem binary )
 #>         ( comparaison entre 2 sytem binary : )
      ( renvoie le booleen TRUE si > sinon FALSE )
 UNTIL              ( sortie de boucle si TRUE : )
                ( adresse courante > adresse fin ) 
 1GETLAM                ( 1re variable locale : )
          ( compteur de blocs de code assembleur )
 #0=?SKIP ( si zro alors saute l'objet suivant: )
                                 ( ici programme )
 ::                  ( dbut structure programme )
  1GETLAM            ( nombre n de blocs de code )
  #1+_ONE_DO (DO)        ( boucle de 1  n + 1 : )
                                 ( en fait 1  n )
  UNROT ( niv. 3: chane listing  niv. 2: bloc i )
                                  ( niv. 1 nom i )
  STO              ( stocke bloc i dans variable )
                               ( globale "Codei" )
  LOOP         ( fin de boucle si indice = n + 1 )
 ;                         ( fin de ce programme )
 ABND                      ( fin d'environnement )
                         ( des variables locales ) 
;                   ( fin de structure programme )
