        DOSSEG
code    segment para 'CODE'
        assume cs:code
        ORG  100h

start:  jmp  strt


POSBYTE EQU  0A1BEh         ; pos. octet  modifier
VALBYTE EQU  16             ; val. octet  modifier

POSCHK  EQU  0A14Ch         ; pos. octet de controle
VALCHK  EQU  035h           ; valeur octet controle

FNAME   DB   "QED95.EXE",0  ; nom du fichier

msg_ok  DB   "File Converted",13,10,"$"
msg_bad DB   "Bad File",13,10,"$"
buffer  DB   (?)            ; buffer lecture/ecriture

strt:   mov  ax,3d02h       ; ouverture fichier
        mov  dx,offset FNAME
        int  21h
        jc   error          ; si carry -> erreur
        mov  bx,ax
        mov  ax,4200h       ; posit. sur oct. contr.
        xor  cx,cx
        mov  dx,POSCHK
        int  21h
        jc   error
        mov  ah,3Fh         ; lecture octet controle
        mov  cx,1
        mov  dx,offset buffer
        mov  si,dx
        int  21h
        jc   error
        cmp  byte ptr [si],VALCHK
        jne  error          ; mauvaise valeur, erreur
        mov  ax,4200h       ; posit. / octet  modifier
        xor  cx,cx
        mov  dx,POSBYTE
        int  21h
        jc   error
        mov  byte ptr [si],VALBYTE  ; nouvelle valeur
                                    ;  dans buffer
        mov  ah,40h         ; Ecriture nouvelle valeur
        mov  cx,1
        mov  dx,si
        int  21h
        jc   error
        mov  ah,3eh         ; Fermeture du fichier
        int  21h
        jnc  exit
error:  mov  dx,offset msg_bad
        jmp  exit_1
exit:   mov  dx,offset msg_ok
exit_1: mov  ah,09          ; affichage message
        int  21h
        mov  ah,4ch         ; sortie
        int  21h
Code    ends
        END  start          ; That's All Folks !

